/// This is the base class with member groups.
class Base
{
public:
  Base() {}

  /// @name agroup
  /// @{

  /// @brief Base::a1
  void a1b() {}

  /// @brief Base::a2
  void a2b() {}

  /// @}

  /// @name cgroup
  /// @{

  /// @brief Base::c1
  void c1b() {}

  /// @brief Base::c2
  void c2b() {}

  /// @}
};

/// This is the intermediate class with member groups.
class Intermediate : public Base
{
public:
  Intermediate() {}

  /// @name agroup
  /// @{

  /// @brief Intermediate::a1
  void a1i() {}

  /// @brief Intermediate::a2
  void a2i() {}

  /// @}

  /// @name bgroup
  /// @{

  /// @brief Intermediate::b1
  void b1i() {}

  /// @brief Intermediate::b2
  void b2i() {}

  /// @}
};

/// This is the derived class with member groups.
class Derived : public Intermediate
{
public:
  Derived() {}

  /// @name agroup
  /// @{

  /// @brief Derived::a1
  void a1d() {}

  //////////////////////////////////////////////////////////////////////
  /// @brief Derived::a2
  ///
  //////////////////////////////////////////////////////////////////////
  void a2d() {}

  /// @}

  /// @name bgroup
  /// @{

  /// @brief Derived::b1
  void b1d() {}

  /// @brief Derived::b2
  void b2d() {}

  /// @}

  /// @name cgroup
  /// @{

  /// @brief Derived::c1
  void c1d() {}

  /// @brief Derived::c2
  void c2d() {}

  /// @}
};

